program Down_lap_dipping_fault
  ! Qdome -- Make quarter dome model.
  !
  ! Qdome [n1=400 n2=100 n3=50 o1=0 d1=.004 ... ] > out.H
  !%
  use sep
  use random_mod
  use triangle
  use icai1
  use tcai1

  implicit none
  real                             :: ranget,o1,d1,o2,d2,o3,d3,coefy, coefx,shift,max_throw
  real                             :: gaussvel, throw, rand, t1, t2,nr2, nr3,wt_bnd
  real                             :: frac1, frac2, f1, zrad, xnew, freq_scale,x_val
  real                             :: pi, thetac, dr, x, y, z, rmax
  real                             :: xp, yp, rcap, rad1, rad2, dz,xval,yval,r2,r3
  real                             :: r, t, frac, zcap, ynew, interval , shift_diff,upwt,dwnwt,diffrl,iprl
  real                             ::mean, variance,offset_std
  integer                          :: large, n1, n2, n3, endtaper, stat,stat1,samples,shift_floor,shift_ceil,knownvec1,knownvec2,diff
  integer                          :: i1,  i2, i3, n1a, n1b, it1, it2, i,it,ip
  integer                          ::max_shift
  real                             ::  Ax,By,Cz,x_r,y_r,z_r,a_1
  real, dimension (:),     pointer :: imp, refl, refl1, refl2,shift_trace,erf,offset_gauss
  real, dimension (:,:,:), pointer :: earth,earth_out, earth_in,earth_out_fill,earth_out2
  real, dimension (:,:), pointer   :: tau,test
  real, dimension (:,:,:),allocatable::ellip_wt,ellip_flt_wt,flt_wt_out
  real, dimension (:,:,:), pointer   :: Tau_3D,p_x,p_y, Tau_3D2
  integer, dimension (:,:), pointer   :: tau_int
  integer, dimension (:,:,:), pointer   :: tau_int_3D

  real,dimension(:), pointer        ::sincer
  ! integer, dimension(:,:,:), allocatable    :: knownvec
  integer, dimension(:,:,:,:), allocatable    :: knownvec


  call sep_init ()
  call from_par ("ranget", ranget, 3.)
  call from_either ("n1", n1, 256)
  call from_either ("n2", n2, 128)
  call from_either ("n3", n3, 128 )


  call from_either ("large", large, int(n1*ranget))
  call to_history ("esize",4)

  call from_par ("d1", d1, .004) ; call from_par ("o1", o1, 0.   )  
  call from_par ("d2", d2, .01 ) ; call from_par ("o2", o2, -3*d2)
  call from_par ("d3", d3, .02 ) ; call from_par ("o3", o3, -3*d3)

  call from_par ("gaussvel", gaussvel,2.5)
  call from_par ("throw", throw, .01)
  call from_par ("endtaper", endtaper, 20)
  call from_par ("mean", mean, 0.)
  call from_par ("variance", variance, 1.)
  call from_par ("max_shift", max_shift, 20)
  call from_par ("Ax", Ax, 40.)
  call from_par ("By", By, 40.)
  call from_par ("Cz", Cz, 40.)
  call from_par ("max_throw", max_throw, 40.)

  o1=0.;o2=0.;o3=0.
  call to_history ("label1","sec")
  call to_history ("label2","W-E,km")
  call to_history ("label3","N-S,km")
  call to_history ("d1",d1)
  call to_history ("d2",d2)
  call to_history ("d3",d3)
  call to_history("o1",o1); call to_history("o2",o2)
  call to_history("o3",o3)

  call to_history ("n1",n1)
  call to_history ("n2",n2)
  call to_history ("n3",n3)

  allocate (imp(large), earth(n1,n2,n3),earth_in(large,n2,n3), refl (n1),tau(n2,n3),tau_3D(n1,n2,n3),tau_3D2(n1,n2,n3),tau_int(n2,n3),tau_int_3D(n1,n2,n3),p_x(n1,n2,n3),p_y(n1,n2,n3))

  call random_init (19921995)

  imp(1) = 0.
  do i1= 2, large 
     call random (rand)
     if (rand > .3) then
        imp(i1) = imp(i1-1)
     else 
        call random (rand)
        imp(i1) = .1 * rand
     end if
  end do


  !create the 1D trace
  do i1= 2, large  
     imp(i1) = imp(i1) + imp(i1-1)
  end do

  earth = 1.0

  pi     = 4. * atan(1.)
  thetac = 45 * 2*pi/360.
  dr = abs(d2) + abs(d1)
  x = o2+d2*(n2-1)
  y = o3+d3*(n3-1)
  rmax = sqrt( x**2 + y**2 ) + dr
  xp = 0.75 * x
  yp = 0.75 * y
  rcap = 0.3 * rmax
  rad1 = (xp**2 + yp**2) - rcap
  rad2 = (xp**2 + yp**2)
  n1a = .15 * n1
  n1b = .8  * n1
  dz = 1./(n1b-n1a)

  do i3= 1, n3   
     y = o3+d3*(i3-1)
     do i2= 1, n2
        x = o2+d2*(i2-1)
        r =sqrt( x**2 + y**2)  + dr/2.
        earth (1 : n1a-1,i2,i3) = 1. + (imp(2:n1a) - imp(:n1a-1))
        ! shallow beds
        do i1=    n1b+1, n1      ! deep beds
           t = i1 +.3 * i2 +.2 * i3
           it1  = t
           it2  = t+1
           frac = t - it1
           interval = &
           ((imp( it2) * (1.-frac) + imp( it2+1) * frac) - &
           (imp( it1) * (1.-frac) + imp( it1+1) * frac))
           earth( i1, i2, i3) =  1.0   + interval
        end do

        do i1= n1a, n1b 
           z = float( i1 - n1a) / (n1b - n1a) ! 0 to 1
           zcap = z * gaussvel /4.0
           z = dz + (1-2*dz) * z   ! dz to 1-dz

           t1 = (large/gaussvel) * (r/rmax) / sqrt( -alog( z-dz/2))
           t2 = (large/gaussvel) * (r/rmax) / sqrt( -alog( z+dz/2))

           t1 = (large/gaussvel) * (r/rmax) * sqrt( -alog( z+dz/2))
           t2 = (large/gaussvel) * (r/rmax) * sqrt( -alog( z-dz/2))

           if( t1 > t2) call erexit('misconception')

           xnew = cos(thetac) * (x-xp) + sin(thetac) * (y-yp)
           xnew = xnew * 0.75 
           ynew = -sin(thetac) * (x-xp) + cos(thetac) * (y-yp)
           if ( rcap**2 > ( xnew**2 + ynew**2 + zcap**2 )  ) then
              if (r < rad2) then
                 zrad = (rad2 - r)/rcap 
              else     
                 zrad = 0.0  ! no faulting after center 
              end if
              t1  =  t1  + throw * n1 * zrad 
              t2  =  t2  + throw * n1 * zrad 
           end if
           it1  = t1
           it2  = t2
           if( it1 >=1 .and. it1+1 < large) then
              frac1 = t1 - it1
              if( it2 >=1 .and. it2+1 < large) then
                 frac2 = t2 - it2
                 interval = &
                 ((imp( it2) * (1.-frac2) + imp( it2+1) * frac2) - &
                 (imp( it1) * (1.-frac1) + imp( it1+1) * frac1))
                 earth( i1, i2, i3) =  1.0   + interval / (t2 - t1)
              end if
           end if
        end do
     end do
  end do

  tau_int_3D=0.
  write(0,*) 'size of imp', size(imp)
  do i3= 1, n3   
     do i2= 1, n2
        !       do i1=1,n1
        earth_in( :, i2, i3) =  imp(:)
        earth(:,i2,i3)=imp(50:n1+50)
        !        end do
     end do
  end do




!!!!! calculate shift cube

  allocate(shift_trace(n1))
  shift_trace=0. 
  coefy=3

  coefx=.6   !.2  !.003
  ! CREATE GAUSSIAN SHIFT
  write(0,*) 'mean',mean,'variance',variance,'max_shift',max_shift
  do i1=1,n1 
     shift_trace(i1)=real(max_shift)*(exp(-.5*((real(i1)-mean)/((variance)**.5))**2.))

  end do


  call auxputch('n1','d',n1,'junk3.H')
  !	call auxputch('n2','d',n2,'junk3.H')
  !	call auxputch('n3','d',n3,'junk3.H')
  !	call auxputch('n4','d',1,'junk3.H')
  call srite("junk3.H",shift_trace,size(shift_trace)*4)

  Tau_3D2=0.
  allocate(offset_gauss(n2),erf(n2))
  offset_std=(real(n2)/6.)
  offset_std=(real(n2)/8.)
  do i2=1,n2
     r2=i2
     nr2=n2
     r3=i3
     nr3=n3
     offset_gauss(i2)=1./((2.*pi*offset_std)**2.)*(exp(-.5*(((r2-nr2/2.)/offset_std)**2.))) 
  end do
  erf=0.
  do i2=1,n2  
     r2=i2
     nr2=n2
     r3=i3
     nr3=n3
     erf(i2)=sum(offset_gauss(1:i2))
  end do
  erf=erf/erf(n2)
  call auxputch('n1','d',n2,'erf.H')
  call srite("erf.H",erf,n2*4)


  do i2=1,n2
     do i3=1,n3
        do i1=1,n1
           r2=i2
           nr2=n2
           r3=i3
           nr3=n3
           !        Tau_3D(:,i2,i3)=-coefx*shift_trace*(r2-1.)



           !  Tau_3D(i1,i2,i3)=((r2-1.)/(nr2-1.)) * (shift_trace(i1))+((r3-1.)/(nr3-1.)) * (shift_trace(i1))


           ! NON-LINEAR
           Tau_3D(i1,i2,i3)=(exp(-.5*((r2+r3-(n2+n3)/2)/((nr2+nr3)/2))**2.))*(shift_trace(i1))
           Tau_3D(i1,i2,i3)=(exp(-.5*((r2-(n2)/2)/((nr2)/2))**2.))*(shift_trace(i1))
           Tau_3D(i1,i2,i3)=(erf(r2)*(shift_trace(i1)))

           ! Tau_3D(i1,i2,i3)=((r2+r3)/(nr2+nr3)) * (shift_trace(i1))
!!$            if (i1+floor(Tau_3D(i1,i2,i3))>1 .and.i1+floor(Tau_3D(i1,i2,i3))<n1) then 
!!$           Tau_3D2(i1+floor(Tau_3D(i1,i2,i3)),i2,i3)=Tau_3D(i1,i2,i3) !+i1
!!$            end if
           Tau_3D2(i1,i2,i3)= Tau_3D(i1,i2,i3)
           !write(0,*) Tau_3D(n1,i2,i3)

        end do
     end do
  end do

  !
  !CREATE ELLIPSOID
  !  Ax=30. ;By=20. ; Cz=25.
  allocate(ellip_wt(2*nint(Cz),2*nint(Ax),2*nint(By)),ellip_flt_wt(2*nint(Cz),2*nint(Ax),2*nint(By)))
  allocate(flt_wt_out(n1,n2,n3))
  ellip_flt_wt=1.
  flt_wt_out=1.
  do i3=1,2*nint(By)
     do i2=1,2*nint(Ax)
        do i1=1,2*nint(Cz)
           x_r=i2-Ax
           y_r=i3-By
           z_r=i1-Cz
           a_1=abs((x_r**2/(1-y_r**2/By-z_r**2/Cz))**.5)
           a_1=abs((x_r**2+y_r**2/(By/Ax)**2+ z_r**2/(Cz/Ax)**2)**.5)
           wt_bnd=abs(((1-z_r**2/Cz**2)*By**2)**.5)
           if (i2>nint(Ax)-2.and.i2<nint(Ax)+2.and.abs(y_r)<=wt_bnd) ellip_flt_wt(i1,i2,i3)=0.
           ellip_wt(i1,i2,i3)=1-a_1/Ax
           if (ellip_wt(i1,i2,i3)<0.) ellip_wt(i1,i2,i3)=0.
           if (x_r>=0) ellip_wt(i1,i2,i3)=ellip_wt(i1,i2,i3)*-1.
        end do
     end do
  end do

  call auxputch('n1','d',2*nint(Cz),'ellip.H')
  call auxputch('n2','d',2*nint(Ax),'ellip.H')
  call auxputch('n3','d',2*nint(By),'ellip.H')
  call srite("ellip.H",ellip_wt,2*nint(Cz)*2*nint(Ax)*2*nint(By)*4)
  !Tau_3D2=0.
  ! APPLY ELLIPSOID
  do i3=1,2*nint(By)
     do i2=1,2*nint(Ax)
        do i1=1,2*nint(Cz)
           Tau_3D2(n1/2-nint(Cz)+i1-1,n2/2-nint(Ax)+i2-1,n3/2-nint(By)+i3-1)=Tau_3D2(n1/2-nint(Cz)+i1-1,n2/2-nint(Ax)+i2-1,n3/2-nint(By)+i3-1)+max_throw*ellip_wt(i1,i2,i3)
           flt_wt_out(n1/2-nint(Cz)+i1-1,n2/2-nint(Ax)+i2-1,n3/2-nint(By)+i3-1)=ellip_flt_wt(i1,i2,i3)
        end do
     end do
  end do

  call auxputch('n1','d',n1,'fault_wt.H')
  call auxputch('n2','d',n2,'fault_wt.H')
  call auxputch('n3','d',n3,'fault_wt.H')
  call srite("fault_wt.H",flt_wt_out,n1*n2*n3*4)

  Tau_3D=0.



!!!!!!!!!!!!!!   linear interpolate 
  write(0,*) 'size of imp', size(imp),'large', large
  allocate(earth_out(n1,n2,n3),earth_out_fill(n1,n2,n3),knownvec(n1,n2,n3,2))
  earth_out=0.
  earth_out_fill=0.
  knownvec=0.










  ! Form reflectivity from impedance.
  refl (1) = 0.
  do i3 = 1, n3
     do i2 = 1, n2
        refl2 => earth (2:    ,i2,i3)
        refl1 => earth ( :n1-1,i2,i3)
        refl (2:) = (refl1 - refl2) / (refl1 + refl2)
        earth (:,i2,i3) = refl
     end do
  end do


  ! temporal smoothing
  do i = 2, 4
     call triangle_init (i, n1)
     do i3 = 1, n3
        do i2 = 1, n2
           stat = triangle_lop (.true.,.false.,refl,earth (:,i2,i3))
           !                          earth (:,i2,i3) = refl
        end do
     end do
     call triangle_close ()
  end do

  refl (1) = 0.
  do i3 = 1, n3
     do i2 = 1, n2
        refl2 => earth (2:    ,i2,i3)
        refl1 => earth ( :n1-1,i2,i3)
        refl (2:) = (refl2 - refl1)
        earth (:,i2,i3) = refl
     end do
  end do





  deallocate(earth_in)
  allocate(earth_in(n1,n2,n3))
  ! large=n1
  earth_in=earth
  earth_out=0.
  earth_out_fill=0.
  knownvec=0.
  !

  do i3=1,n3
     do i2=1,n2
        do i1=1,n1


           !           shift=(time_cube(i1,i2,i3))-time_cube(i1,ref_2,ref_3) !  -5.4
           shift=tau_3D(i1,i2,i3)-tau_3D(i1,1,1)
!!$
!!$           if (time_cube(i1,i2,i3)==0.) then
!!$              shift=0.
!!$           end if

           shift_floor=floor(shift)  ! -6
           !! shift_floor=floor(tau_3D(i1,i2,i3))
           shift_ceil=shift_floor+1 ! -5
           shift_diff=shift-shift_floor !  -5.4 - - 6 =.4

           upwt = shift_diff  !   .4 
           dwnwt= 1-shift_diff !   .6


           if (i1+shift_floor>1 .and. i1+shift_ceil<n1) then 
              earth_out( i1+shift_floor,i2,i3)=earth_out(i1+shift_floor  ,i2,i3)+ dwnwt*earth_in(i1,i2,i3)!(i1+int((large-n1)/2.),i2,i3)
              earth_out( i1+shift_ceil ,i2,i3)=earth_out(i1+shift_ceil   ,i2,i3)+ upwt*earth_in(i1,i2,i3) !i1+int((large-n1)/2.),i2,i3)


           end if



        end do
     end do
  end do
  !tau_3D=0.
  !call sreed("intau.H", tau_3D,4*n1*n2*n3)
  !allocate(earth_out2(n1,n2,n3))
  call sep_close



  do i3=1,n3
     do i2=1,n2
        do i1=1,n1-1
           knownvec1=knownvec(i1,i2,i3,2)  ;
           knownvec2=knownvec(i1+1,i2,i3,1);


           diff=knownvec2-knownvec1 
           if (diff >=2)  then
              do ip=1,diff-1
                 iprl=ip 
                 diffrl=diff 
!!$                 earth_out(knownvec1+ip,i2)=earth_out(knownvec1,i2)*(1.-iprl/diffrl)+earth_out(knownvec2,i2)*(iprl/diffrl) 
              end do
           end if
        end do
     end do
  end do


  earth=earth_out



  p_x=0.
  p_y=0.
  do i2=1,n2-1
     do i3=1,n3-1
        do i1=1,n1
           r2=i2
           nr2=n2
           r3=i3
           nr3=n3
           !        Tau_3D(:,i2,i3)=-coefx*shift_trace*(r2-1.)

           p_x(i1,i2,i3)=Tau_3D2(i1,i2+1,i3)-Tau_3D2(i1,i2,i3)
           p_y(i1,i2,i3)=Tau_3D2(i1,i2,i3+1)-Tau_3D2(i1,i2,i3)
           !write(0,*) Tau_3D(n1,i2,i3)
        end do
     end do
  end do

  call to_history("n1",n1,"tau"); call to_history("n2",n2,"tau")
  call to_history("n3",n3,"tau")
  call to_history("d1",d1,"tau"); call to_history("d2",d2,"tau")
  call to_history("d3",d3,"tau")
  call to_history("o1",o1,"tau"); call to_history("o2",o3,"tau")
  call to_history("o3",o3,"tau")
  call to_history("esize",4,"tau")


  call to_history("n1",n1,"p_x"); call to_history("n2",n2,"p_x")
  call to_history("n3",n3,"p_x")
  call to_history("d1",d1,"p_x"); call to_history("d2",d2,"p_x")
  call to_history("d3",d3,"p_x")
  call to_history("o1",o1,"p_x"); call to_history("o2",o3,"p_x")
  call to_history("o3",o3,"p_x")
  call to_history("esize",4,"p_x")
  call sep_write(p_x,"p_x")	



  call to_history("n1",n1,"p_y"); call to_history("n2",n2,"p_y")
  call to_history("n3",n3,"p_y")
  call to_history("d1",d1,"p_y"); call to_history("d2",d2,"p_y")
  call to_history("d3",d3,"p_y")
  call to_history("o1",o1,"p_y"); call to_history("o2",o3,"p_y")
  call to_history("o3",o3,"p_y")
  call to_history("esize",4,"p_y")
  call sep_write(p_y,"p_y")	

  samples=n1/4
  allocate(sincer(samples),earth_out(n1,n2,n3))
  earth_out=0.


  freq_scale=.7+.03*(n3*n3/8+n2*n2/8)**(.5) !for a constant frequency
  do it=1,samples
     x_val=-3.+(it-1.)*(6./(samples-1.))
     sincer(it)=sin((x_val*freq_scale*pi))/(x_val*freq_scale*pi)
     sincer(1:samples/2-int((samples/(3*freq_scale))))=0
     sincer(samples/2+int((samples/(3*freq_scale))):)=0 
  end do
  call icai1_init(sincer,nint(size(sincer)/2.))!size(sincer))

  do i3= 1, n3   
     do i2= 1, n2
        r2=i2
        r3=i3 
        stat1=icai1_lop(.false.,.false.,earth(:,i2,i3),earth_out(:,i2,i3))
        !    call icai1_close()
     end do
  end do
  call icai1_close()
  earth=0.
  earth=earth_out
  call sep_write(Tau_3D2,"tau")	
  f1 = real(endtaper)
  do i1 = 1, endtaper
     earth (     i1   ,:,:) = earth (     i1    ,:,:) * i1  / f1
     earth (n1 - i1 +1,:,:) = earth (n1 - i1 + 1,:,:) * i1  / f1
  end do

  call sep_write (earth)



  deallocate (earth, imp, refl)

  call exit (0)
end program Down_lap_dipping_fault




























