module dipinteg_3Dcos
  use sep
  use dottest
  use fftwflags
  use fft_types

  integer, save               ::n1_in,n2_in,n3_in
  real, save, allocatable     :: cos_1d_1axis(:),cos_1d_1axis_out(:), cos_1d_2axis(:),cos_1d_2axis_out(:),cos_1d_3axis(:),cos_1d_3axis_out(:)


contains
  subroutine dipinteg_3Dcos_init( n1,n2,n3)
    integer n1,n2,n3
    n1_in=n1;n2_in=n2;n3_in=n3				

  end subroutine dipinteg_3Dcos_init
  subroutine dipinteg_2Dcos_init( n1,n2)
    integer n1,n2
    n1_in=n1;n2_in=n2				

  end subroutine dipinteg_2Dcos_init

  subroutine dipinteg_3Dcos_close()

  end subroutine dipinteg_3Dcos_close


  subroutine dipinteg_3Dcos_exec( rt_3D,cos_trans)
    integer		       :: ct,cx,cy
    real                      :: cos_trans(:,:,:),rt_3D(:,:,:)
    integer*8                :: plan
    include "/net/koko/linux_local/FFTW/FFT3_INTEL/include/fftw3.f"
    call sfftw_plan_r2r_3d(plan,n1_in,n2_in,n3_in,rt_3D ,rt_3D,FFTW_REDFT10,FFTW_REDFT10,FFTW_REDFT10,FFTW_ESTIMATE)
    call sfftw_execute(plan) 
    call sfftw_destroy_plan(plan) 
    where (cos_trans(:,:,:)>.000001) rt_3D=(rt_3D*cos_trans(:,:,:))/(cos_trans(:,:,:)*cos_trans(:,:,:)+.000000001)
       call sfftw_plan_r2r_3d(plan,n1_in,n2_in,n3_in,rt_3D ,rt_3D,FFTW_REDFT01,FFTW_REDFT01,FFTW_REDFT01,FFTW_ESTIMATE)
       call sfftw_execute(plan) 
       call sfftw_destroy_plan(plan)    
       rt_3D=rt_3D/(8.*(n1_in*n2_in*n3_in))
     end subroutine dipinteg_3Dcos_exec

     subroutine dipinteg_2Dcos_exec( rt_2D,cos_trans)
       integer		       :: ct,cx,cy
       real                      :: cos_trans(:,:),rt_2D(:,:)
       integer*8                :: plan
       include "/net/koko/linux_local/FFTW/FFT3_INTEL/include/fftw3.f"
       call sfftw_plan_r2r_2d(plan,n1_in,n2_in,rt_2D ,rt_2D,FFTW_REDFT10,FFTW_REDFT10,FFTW_REDFT10,FFTW_ESTIMATE)
       call sfftw_execute(plan) 
       call sfftw_destroy_plan(plan) 
       where (cos_trans>.000001) rt_2D=(rt_2D*cos_trans)/(cos_trans*cos_trans+.000000001)
          call sfftw_plan_r2r_2d(plan,n1_in,n2_in,rt_2D ,rt_2D,FFTW_REDFT01,FFTW_REDFT01,FFTW_REDFT01,FFTW_ESTIMATE)
          call sfftw_execute(plan) 
          call sfftw_destroy_plan(plan)    
          rt_2D=rt_2D/(4.*(n1_in*n2_in))
        end subroutine dipinteg_2Dcos_exec



      end module dipinteg_3Dcos
